Drag and drop list items in Vue ListView component

21 Feb 20259 minutes to read

The ListView component doesn’t have built-in drag and drop support. However, we can achieve this functionality using the TreeView component with ListView appearance.

Drag and Drop in the TreeView component is enabled by setting allowDragAndDrop to true.

<ejs-treeview id='element' :fields='fields' allowDragAndDrop='true'></ejs-treeview>

The TreeView component is used to represent hierarchical data in a tree-like structure. As a result, list items in TreeView can be dropped as children of the target element. We can prevent this behavior by cancelling thenodeDragStop and nodeDragging events.

<ejs-treeview id='element' :fields='fields' allowDragAndDrop='true' :nodeDragging='onDragStop' :nodeDragStop='onDragStop'></ejs-treeview>

fields: { dataSource: data, id: 'id', text: 'text' },

onDragStop: function(args) {
    //Block the Child Drop operation in TreeView.
   let  draggingItem = document.getElementsByClassName("e-drop-in");
    if (draggingItem.length == 1) {
        draggingItem[0].classList.add('e-no-drop');
        args.cancel = true;
    }
}

In the sample below, we have rendered draggable list items.

<template>
    <div id="sample">
      <ejs-treeview id='element' :fields='fields' allowDragAndDrop='true' :nodeDragging='onDragStop'
        :nodeDragStop='onDragStop'></ejs-treeview>
    </div>
  </template>
  
  <script setup>
  
  import { TreeViewComponent as EjsTreeview } from "@syncfusion/ej2-vue-navigations";
  
  
  
  var data = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
  ];
  
  const fields = { dataSource: data, id: 'id', text: 'text' };
  
  
  const onDragStop = (args) => {
    //Block the Child Drop operation in TreeView
    let draggingItem = document.getElementsByClassName("e-drop-in");
    if (draggingItem.length == 1) {
      draggingItem[0].classList.add('e-no-drop');
      args.cancel = true;
    }
  };
  
  </script>
  <style>
  #sample {
    display: block;
    max-width: 280px;
    margin: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
  }
  
  #element.e-treeview .e-ul {
    padding: 0;
  }
  
  #element.e-treeview .e-list-item {
    padding: 0 16px;
  }
  
  #element.e-treeview .e-text-content {
    padding: 0;
  }
  
  #element.e-treeview .e-fullrow {
    height: 36px;
  }
  
  #element.e-treeview .e-list-text {
    line-height: 34px;
  }
  
  #element.e-treeview .e-list-item:last-child {
    margin-bottom: 9px;
  }
  
  #element.e-treeview .e-list-item:first-child {
    margin-top: 9px;
  }
  </style>
<template>
    <div id="sample">
      <ejs-treeview id='element' :fields='fields' allowDragAndDrop='true' :nodeDragging='onDragStop'
        :nodeDragStop='onDragStop'></ejs-treeview>
    </div>
  </template>
  
  <script>
  
  import { TreeViewComponent } from "@syncfusion/ej2-vue-navigations";
  
  
  
  export default {
    name: "App",
    components: {
      "ejs-treeview": TreeViewComponent
    },
    data: function () {
      var data = [
        { text: 'Hennessey Venom', id: 'list-01' },
        { text: 'Bugatti Chiron', id: 'list-02' },
        { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
        { text: 'SSC Ultimate Aero', id: 'list-04' },
        { text: 'Koenigsegg CCR', id: 'list-05' },
        { text: 'McLaren F1', id: 'list-06' },
        { text: 'Aston Martin One- 77', id: 'list-07' },
        { text: 'Jaguar XJ220', id: 'list-08' },
        { text: 'McLaren P1', id: 'list-09' },
        { text: 'Ferrari LaFerrari', id: 'list-10' },
      ];
      return {
        fields: { dataSource: data, id: 'id', text: 'text' },
      };
    },
    methods: {
      onDragStop: function (args) {
        //Block the Child Drop operation in TreeView
        let draggingItem = document.getElementsByClassName("e-drop-in");
        if (draggingItem.length == 1) {
          draggingItem[0].classList.add('e-no-drop');
          args.cancel = true;
        }
      }
    }
  }
  </script>
  <style>
  #sample {
    display: block;
    max-width: 280px;
    margin: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
  }
  
  #element.e-treeview .e-ul {
    padding: 0;
  }
  
  #element.e-treeview .e-list-item {
    padding: 0 16px;
  }
  
  #element.e-treeview .e-text-content {
    padding: 0;
  }
  
  #element.e-treeview .e-fullrow {
    height: 36px;
  }
  
  #element.e-treeview .e-list-text {
    line-height: 34px;
  }
  
  #element.e-treeview .e-list-item:last-child {
    margin-bottom: 9px;
  }
  
  #element.e-treeview .e-list-item:first-child {
    margin-top: 9px;
  }
  </style>

Drag and drop list items in React ListView component

23 Jan 202510 minutes to read

The ListView component doesn’t have built-in drag and drop support. However, we can achieve this functionality using the TreeView component with ListView appearance.

Drag and Drop in the TreeView component can be enabled by setting allowDragAndDrop to true.

  <TreeViewComponent id='treeview'
          dataSource={data}
          allowDragAndDrop = {true}
          fields= {field} >
  </TreeViewComponent>

The TreeView component is used to represent hierarchical data in a tree-like structure. By default, list items in TreeView can be dropped as children of target elements. We can prevent this behavior by canceling the nodeDragStop and nodeDragging events.

function onDragStop(args: DragAndDropEventArgs) {
    //Block the Child Drop operation in TreeView
   let  draggingItem: HTMLCollection = document.getElementsByClassName("e-drop-in");
    if (draggingItem.length == 1) {
        draggingItem[0].classList.add('e-no-drop');
        args.cancel = true;
    }
}

return (
  <TreeViewComponent id='treeview'
          dataSource={data}
          allowDragAndDrop = {true}
          nodeDragging = {onDragStop.bind(this)}
          nodeDragStop = {onDragStop.bind(this)}
          fields= {field} >
  </TreeViewComponent>
)
function onDragStop(args) {
    //Block the Child Drop operation in TreeView
    let draggingItem = document.getElementsByClassName("e-drop-in");
    if (draggingItem.length == 1) {
        draggingItem[0].classList.add('e-no-drop');
        args.cancel = true;
    }
}
return (<TreeViewComponent id='treeview' dataSource={data} allowDragAndDrop={true} nodeDragging={onDragStop.bind(this)} nodeDragStop={onDragStop.bind(this)} fields={field}>
  </TreeViewComponent>);

In the below sample, we have rendered draggable list items.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import './index.css';
function App() {
    //Define an array of JSON data
    let data = [
        { text: "Hennessey Venom", id: "list-01" },
        { text: "Bugatti Chiron", id: "list-02" },
        { text: "Bugatti Veyron Super Sport", id: "list-03" },
        { text: "SSC Ultimate Aero", id: "list-04" },
        { text: "Koenigsegg CCR", id: "list-05" },
        { text: "McLaren F1", id: "list-06" },
        { text: "Aston Martin One- 77", id: "list-07" },
        { text: "Jaguar XJ220", id: "list-08" },
        { text: "McLaren P1", id: "list-09" },
        { text: "Ferrari LaFerrari", id: "list-10" }
    ];
    let field = { dataSource: data, id: "id", text: "text" };
    function onDragStop(args) {
        //Block the Child Drop operation in TreeView
        let draggingItem = document.getElementsByClassName("e-drop-in");
        if (draggingItem.length == 1) {
            draggingItem[0].classList.add("e-no-drop");
            args.cancel = true;
        }
    }
    return (<TreeViewComponent id="treeview" allowDragAndDrop={true} nodeDragging={onDragStop.bind(this)} nodeDragStop={onDragStop.bind(this)} fields={field} />);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { DragAndDropEventArgs } from '@syncfusion/ej2-navigations';

function App() {
  //Define an array of JSON data
  let data: any[] = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" },
    { text: "Aston Martin One- 77", id: "list-07" },
    { text: "Jaguar XJ220", id: "list-08" },
    { text: "McLaren P1", id: "list-09" },
    { text: "Ferrari LaFerrari", id: "list-10" }
  ];

  let field: object = { dataSource: data, id: "id", text: "text" };

  function onDragStop(args: DragAndDropEventArgs) {
    //Block the Child Drop operation in TreeView
    let draggingItem: HTMLCollection = document.getElementsByClassName("e-drop-in");
    if (draggingItem.length == 1) {
      draggingItem[0].classList.add("e-no-drop");
      args.cancel = true;
    }
  }

  return (
    <TreeViewComponent
      id="treeview"
      allowDragAndDrop={true}
      nodeDragging={onDragStop.bind(this) as any}
      nodeDragStop={onDragStop.bind(this) as any}
      fields={field}
    />
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  font-family: 'Helvetica Neue', 'calibiri';
  font-size: 14px;
  top: 45%;
  left: 45%;
}

#element {
  display: block;
  max-width: 280px;
  margin: auto;
  border: 1px solid #dddddd;
  border-radius: 3px;
}

#treeview.e-treeview .e-ul,
#treeview.e-treeview .e-text-content {
  padding: 0;
}

#treeview.e-treeview .e-list-item {
  padding: 0 16px;
}

#treeview.e-treeview .e-fullrow {
  height: 36px;
}

#treeview.e-treeview .e-list-text {
  line-height: 34px;
}

#treeview.e-treeview .e-list-item:last-child {
  margin-bottom: 9px;
}

#treeview.e-treeview .e-list-item:first-child {
  margin-top: 9px;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-react-navigations/styles/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='element'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Drag and drop list items in Angular ListView component

10 Sep 20255 minutes to read

The ListView component can be enhanced with drag and drop functionality by utilizing the TreeView component while maintaining a ListView appearance.

First, import the required TreeView module:

import { TreeViewModule } from '@syncfusion/ej2-angular-navigations';

Enable drag and drop functionality in TreeView by setting the allowDragAndDrop property to true:

<ejs-treeview id='element' [fields]='fields' allowDragAndDrop='true'></ejs-treeview>

The TreeView component displays data in a hierarchical structure. To maintain a flat list appearance, prevent nested dropping by handling the nodeDragStop and nodeDragging events:

<ejs-treeview id='element' [fields]='fields' allowDragAndDrop='true' (nodeDragging)='onDragStop($event)' (nodeDragStop)='onDragStop($event)'></ejs-treeview>

fields= { dataSource: this.data, id: 'id', text: 'text' },

onDragStop(args: any) {
    // Prevent nested drop operations
   const draggingItem = document.getElementsByClassName("e-drop-in");
    if (draggingItem.length == 1) {
        draggingItem[0].classList.add('e-no-drop');
        args.cancel = true;
    }
}

The following example demonstrates draggable list items implementation:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeViewModule } from '@syncfusion/ej2-angular-navigations'
import { Component, ViewChild } from '@angular/core';

@Component({
    imports: [
        TreeViewModule
    ],
    standalone: true,
    selector: 'my-app',
    template: `
          <div id="sample">
    <ejs-treeview id='element' [fields]='fields' allowDragAndDrop='true' (nodeDragging)='onDragStop($event)' (nodeDragStop)='onDragStop($event)'></ejs-treeview>
   </div>
        `,
})

export class AppComponent {
    public data = [
        { text: 'Hennessey Venom', id: 'list-01' },
        { text: 'Bugatti Chiron', id: 'list-02' },
        { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
        { text: 'SSC Ultimate Aero', id: 'list-04' },
        { text: 'Koenigsegg CCR', id: 'list-05' },
        { text: 'McLaren F1', id: 'list-06' },
        { text: 'Aston Martin One- 77', id: 'list-07' },
        { text: 'Jaguar XJ220', id: 'list-08' },
        { text: 'McLaren P1', id: 'list-09' },
        { text: 'Ferrari LaFerrari', id: 'list-10' },
    ];
    public fields = { dataSource: this.data, id: 'id', text: 'text' };
    onDragStop(args: any) {
        //Block the Child Drop operation in TreeView
        let draggingItem = document.getElementsByClassName("e-drop-in");
        if (draggingItem.length == 1) {
            draggingItem[0].classList.add('e-no-drop');
            args.cancel = true;
        }
    }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-lists/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-popups/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-inputs/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-grids/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-navigations/styles/material.css';


#sample {
    display: block;
    max-width: 280px;
    margin: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}

#element.e-treeview .e-ul {
    padding: 0;
}

#element.e-treeview .e-list-item {
    padding: 0 16px;
}

#element.e-treeview .e-text-content {
    padding: 0;
}

#element.e-treeview .e-fullrow {
    height: 36px;
}

#element.e-treeview .e-list-text {
    line-height: 34px;
}

#element.e-treeview .e-list-item:last-child {
    margin-bottom: 9px;
}

#element.e-treeview .e-list-item:first-child {
    margin-top: 9px;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));